<template>
  <div style="margin: 3rem">
    <header style="margin:10rem 6rem 3rem 6rem">
      <ReturnButton :offsetArrow="20" :spanTitle="3" title="Menú Principal" v-on:clickEvent="returnPage" style="margin-bottom:2.5rem"></ReturnButton>
    </header>

    <!-- COMPONENTE TITULO -->
    <div style="margin:3rem 6rem 0rem">
      <app-title Title="REVISIÓN DE MATERIALES ENLATADOS" bgColor="background-color: #4A4A4A !important"> </app-title>
    </div> 
    <el-main style="margin:0rem 6rem; min-height: 300px">
      <el-row 
        v-if="(movCount == 0) && (novCount == 0) && (serCount == 0) && (carCount == 0) && (minCount == 0) && (specialsCount == 0)" v-loading="loading" :element-loading-text="loadingText">
        <el-col :span="24" style="display: flex; justify-content: center;" v-show="!loading">
          <img src="@/assets/images/no-materiales.svg">
        </el-col>
      </el-row>
      <el-row v-else type="flex" style="flex-wrap: wrap">
        <el-col v-for="(card, index) in getDataCards()" :key="index" class="text-center with-cards" style="padding: 10px 50px 50px;" v-if="card.conditional > 0">
            <app-cardReviewHome
              @goTo="materialCannedToGo(card.lowerText, card.name)"
              :titleTop="true" 
              :textTop="showName(card.name)" 
              :titleBottom="false" 
              :styleTitleTop="card.styleTitleTop" 
              :colorCaret="card.colorCaret"
              :rutaImg="card.img"
              :styleCard="card.styleCard">
            </app-cardReviewHome>
        </el-col>
      </el-row>
    </el-main>
  </div>
</template>

<script>
import ReturnButton from '@/components/ReturnButton.vue'
import cardReviewHome from '@/components/cardReviewHome.vue'
import Title from '@/components/Title.vue'
import { HTTP } from '../../main.js'

export default {
  components: {
    'app-cardReviewHome': cardReviewHome,
    'app-title': Title,
    ReturnButton
  },
  data () {
    return {
      /*MATERIALES ENLATADOS CON CONTRATO*/
      movCount: 0,
      novCount: 0,
      serCount: 0,
      minCount: 0,
      carCount: 0,
      specialsCount: 0,
      /*Add new cards*/
      cookCounter: 0,
      comicCounter: 0,
      deportCounter: 0,
      entertainmentCounter: 0,
      interviewCounter: 0,
      childCounter: 0,
      magazineCounter: 0,
      microprogramCounter: 0,
      periodisticoCounter: 0,
      programEspecialCounter: 0,
      religiousCounter: 0,
      talkshowCounter: 0,
      electoralCounter: 0,
      femaleCounter: 0,
      politicalCounter: 0,
      contractName: '',
      links: [],
      loading: true,
      loadingText: 'Cargando Materiales Enlatados...',
      // typeOfContent: localStorage.getItem('typeOfContent'),
    }
  },
  created () {
    /*MATERIALES ENLATADOS CON CONTRATO*/
    this.novCount = this.$store.state.Novelas.length
    this.serCount = this.$store.state.Series.length
    this.carCount = this.$store.state.Dibujos.length
    this.movCount = this.$store.state.Largometrajes.length
    this.minCount = this.$store.state.Miniseries.length
    this.specialsCount = this.$store.state.Especial.length
    this.cookCounter = this.$store.state.Cocina.length
    this.comicCounter = this.$store.state.comico.length
    this.deportCounter = this.$store.state.Deportivo.length
    this.entertainmentCounter = this.$store.state.Entretenimiento.length
    this.interviewCounter = this.$store.state.Entrevista.length
    this.childCounter = this.$store.state.infantil.length
    this.magazineCounter = this.$store.state.Magazine.length
    this.microprogramCounter = this.$store.state.Microprograma.length
    this.periodisticoCounter = this.$store.state.Periodistico.length
    this.programEspecialCounter = this.$store.state.programEspecial.length
    this.religiousCounter = this.$store.state.religioso.length
    this.talkshowCounter = this.$store.state.talkshow.length
    this.electoralCounter = this.$store.state.Electoral.length
    this.femaleCounter = this.$store.state.Femenino.length
    this.politicalCounter = this.$store.state.politico.length

    // /*Add new cards*/
    this.getDataStore()
    this.viewHaveContent(this.isNotContent)
  },
  computed: {
    multiplerFilter() {
      const array = [
        this.movCount,
        this.novCount,
        this.serCount,
        this.minCount,
        this.carCount,
        this.specialsCount,
        this.cookCounter,
        this.comicCounter,
        this.deportCounter,
        this.entertainmentCounter,
        this.interviewCounter,
        this.childCounter,
        this.magazineCounter,
        this.microprogramCounter,
        this.periodisticoCounter,
        this.programEspecialCounter,
        this.religiousCounter,
        this.talkshowCounter,
        this.electoralCounter,
        this.femaleCounter,
        this.politicalCounter
      ].join()
      return array
    },
    isNotContent() {
      if(
        this.movCount == 0 &&
        this.novCount == 0 &&
        this.serCount == 0 &&
        this.minCount == 0 &&
        this.carCount == 0 &&
        this.specialsCount == 0 &&
        this.cookCounter == 0 &&
        this.comicCounter == 0 &&
        this.deportCounter == 0 &&
        this.entertainmentCounter == 0 &&
        this.interviewCounter == 0 &&
        this.childCounter == 0 &&
        this.magazineCounter == 0 &&
        this.microprogramCounter == 0 &&
        this.periodisticoCounter == 0 &&
        this.programEspecialCounter == 0 &&
        this.religiousCounter == 0 &&
        this.talkshowCounter == 0 &&
        this.electoralCounter == 0 &&
        this.femaleCounter == 0 &&
        this.politicalCounter == 0
      ) {
        return true
      } else {
        return false
      }
    }
  },
  methods: {
    viewHaveContent(data) {
      if(data == true) {
        setTimeout(() => {
          this.loading = false
        }, 1000)
      }
    },
    getMaterial(material, value){
      HTTP.get('materials/materialType/Enlatado/typeOfContent/'+ material + '/providerName')
        .then(res => {
          this[value] = res.data.count
        })
        .catch(err => {
          console.log(err);
        });
    },
    returnPage () {
      this.$router.push({ name: 'review'})
    },
    materialCanned(mtype, string) {
      this.$localStorage.set('afiliado', false )
      if( mtype !== 'novels' && mtype !== 'cartoons' && mtype !== 'series') {
        this.$localStorage.set('typeMaterialR', string)
        this.$router.push({ name: mtype, params: { canned: true } });
      }
      else {
        this.$router.push({ name: 'novels', params: { canned: true } });
        this.$localStorage.set('typeMaterialR', string)
        this.$localStorage.set('enlatado', true )
      }
    },
    materialCannedToGo(query, subTitle) {
      this.$localStorage.set('typeOfContent', subTitle)
      this.$router.push({ name: "typeMaterial",  params: {name: subTitle}});
    },
    getDataCards() {
      let dataCards = [
        {lowerText: 'largometrajes', name: 'Largometrajes', conditional: this.movCount, styleTitleTop: 'color-blue', colorCaret: 'color-lightblue', img: require(`@/assets/images/largometraje.svg`), styleCard: 'border-card-movie'},

        {lowerText: 'novels', name: 'Novelas', conditional: this.serCount, styleTitleTop: 'color-pink', colorCaret: 'color-blue', img: require(`@/assets/images/novela.svg`), styleCard: 'border-card-novels'},
        
        {lowerText: 'series', name: 'Series', conditional: this.serCount, styleTitleTop: 'color-lightblue', colorCaret: 'color-pink', img: require(`@/assets/images/serie.svg`), styleCard: 'border-card-series'},

        {lowerText: 'miniseries', name: 'Miniseries', conditional: this.minCount, styleTitleTop: 'color-purple', colorCaret: 'color-yellow', img: require(`@/assets/images/miniserie.svg`), styleCard: 'border-card-miniseries'},

        {lowerText: 'cartoons', name: 'Dibujos', conditional: this.carCount, styleTitleTop: 'color-yellow', colorCaret: 'color-lightgreen', img: require(`@/assets/images/dibujo.svg`), styleCard: 'border-card-cartoons'},

        {lowerText: 'specials', name: 'Especial', conditional: this.carCount, styleTitleTop: 'color-lightgreen', colorCaret: 'color-purple', img: require(`@/assets/images/especiales.svg`), styleCard: 'border-card-specials'},

        {lowerText: 'cook', name: 'Cocina', conditional: this.cookCounter, styleTitleTop: 'color-gold', colorCaret: 'color-gray', img: require(`@/assets/images/icono-cocina.svg`), styleCard: 'border-card-cook'},

        {lowerText: 'comic', name: 'Cómico', conditional: this.cookCounter, styleTitleTop: 'color-lightpurple', colorCaret: 'color-purple', img: require(`@/assets/images/icono-cómico.svg`), styleCard: 'bg-lightpurple'},

        {lowerText: 'deport', name: 'Deporte', conditional: this.deportCounter, styleTitleTop: 'color_light_blue', colorCaret: 'color-lightpurple', img: require( `@/assets/images/icono-deportivo.svg`), styleCard: 'bg-lightblue'},

        {lowerText: 'entreteiment', name: 'Entretenimiento', conditional: this.entertainmentCounter, styleTitleTop: 'color-pink-card', colorCaret: 'color-darkblue', img: require(`@/assets/images/icono-entretenimiento.svg`), styleCard: 'bg-pinkCard'},

        {lowerText: 'interview', name: 'Entrevista', conditional: this.interviewCounter, styleTitleTop: 'color-magenta', colorCaret: 'color-darkpink', img: require(`@/assets/images/icono-entrevista.svg`), styleCard: 'border-card-interview'},

        {lowerText: 'childs', name: 'Infantil', conditional: this.childCounter, styleTitleTop: 'color-card-child', colorCaret: 'color-purple', img: require(`@/assets/images/icono-infantil.svg`), styleCard: 'border-card-child'},

        {lowerText: 'magazine', name: 'Magazine', conditional: this.magazineCounter, styleTitleTop: 'color-green', colorCaret: 'color-card-child', img: require(`@/assets/images/icono-magazine.svg`), styleCard: 'border-card-magazine'},

        {lowerText: 'microprogram', name: 'Microprograma', conditional: this.microprogramCounter, styleTitleTop: 'color-lightgray', colorCaret: 'color-darkpink', img: require(`@/assets/images/icono-microprograma.svg`), styleCard: 'border-card-microprograma'},

        {lowerText: 'periodístico', name: 'Periodístico', conditional: this.periodisticoCounter, styleTitleTop: 'color-darkmagenta', colorCaret: 'color-gray', img: require(`@/assets/images/icono-periodístico.svg`), styleCard: 'border-card-periodistico'},

        {lowerText: 'programsEspecial', name: 'Programas Especiales', conditional: this.programEspecialCounter, styleTitleTop: 'color-greenApple', colorCaret: 'color-gold', img: require(`@/assets/images/icono-progespeciales.svg`), styleCard: 'border-card-prog-especial'},

        {lowerText: 'religious', name: 'Religioso', conditional: this.religiousCounter, styleTitleTop: 'color-aqua', colorCaret: 'color-card-child', img: require(`@/assets/images/icono-religioso.svg`), styleCard: 'border-card-religious'},
        
        {lowerText: 'talkshow', name: 'Talkshow', conditional: this.talkshowCounter, styleTitleTop: 'color-darkpink', colorCaret: 'color-magenta', img: require(`@/assets/images/icono-talkshow.svg`), styleCard: 'border-card-talkshow'},

        {lowerText: 'electoral', name: 'Electoral', conditional: this.electoralCounter, styleTitleTop: 'color-darkred', colorCaret: 'color-aqua', img: require(`@/assets/images/icono-electoral.svg`), styleCard: 'border-card-electoral'},

        {lowerText: 'female', name: 'Femenino', conditional: this.femaleCounter, styleTitleTop: 'color-darkpurple', colorCaret: 'color-pink-card', img: require(`@/assets/images/icono-femenino.svg`), styleCard: 'border-card-femenino'},

        {lowerText: 'politic', name: 'Político', conditional: this.politicalCounter, styleTitleTop: 'color-darkblue', colorCaret: 'color-darkmagenta', img: require(`@/assets/images/icono-político.svg`), styleCard: 'border-card-politico'},
      ]
      return dataCards
    },
    showName(val) {
      if(val === 'Especial') {
        return 'Especiales'
      } else {
        return val
      }
    },
    getDataStore() {
      const data = [
        {name: 'Largometrajes', element: 'movCount'},
        {name: 'Novelas', element: 'novCount'},
        {name: 'Series', element: 'serCount'},
        {name: 'Miniseries', element: 'minCount'},
        {name: 'Dibujos', element: 'carCount'},
        {name: 'Especial', element: 'specialsCount'},
        {name: 'Cocina', element: 'cookCounter'},
        {name: 'Cómico', element: 'comicCounter'},
        {name: 'Deportes', element: 'deportCounter'},
        {name: 'Entretenimiento', element: 'entertainmentCounter'},
        {name: 'Entrevista', element: 'interviewCounter'},
        {name: 'Infantil', element: 'childCounter'},
        {name: 'Magazine', element: 'magazineCounter'},
        {name: 'Microprograma', element: 'microprogramCounter'},
        {name: 'Periodístico', element: 'magazineCounter'},
        {name: 'Programas Especiales', element: 'programEspecialCounter'},
        {name: 'Religioso', element: 'religiousCounter'},
        {name: 'Talkshow', element: 'talkshowCounter'},
        {name: 'Electoral', element: 'electoralCounter'},
        {name: 'Femenino', element: 'femaleCounter'},
        {name: 'Político', element: 'politicalCounter'},
      ]
      data.forEach((e) => {
        // this[e.element] = this.$store.state[e.name].length
        this.getMaterial(e.name, e.element)
      })
    }
  },
  watch: {
    multiplerFilter(val) {
      if(
        this.movCount !== 0 &&
        this.novCount !== 0 &&
        this.serCount !== 0 &&
        this.minCount !== 0 &&
        this.carCount !== 0 &&
        this.specialsCount !== 0 &&
        this.cookCounter!== 0 &&
        this.comicCounter!== 0 &&
        this.deportCounter!== 0 &&
        this.entertainmentCounter!== 0 &&
        this.interviewCounter!== 0 &&
        this.childCounter!== 0 &&
        this.magazineCounter!== 0 &&
        this.microprogramCounter!== 0 &&
        this.periodisticoCounter!== 0 &&
        this.programEspecialCounter!== 0 &&
        this.religiousCounter!== 0 &&
        this.talkshowCounter!== 0 &&
        this.electoralCounter!== 0 &&
        this.femaleCounter !== 0 &&
        this.politicalCounter
      ) {
        this.loading = false
      } else {
        this.loading = true
      }
    }
  }
}
</script>